@echo off & @setlocal


echo  ____________________________________________________________________________
echo                                                      http://www.ProCompSys.de
echo.
echo  	version 1.0  2008-05-31 by Uwe Weitz @ ProCompSys
echo. 
echo    LAN-Verbindung am Switch oder Router zum_Blinken bringen
echo    fr Windows 2000 ^& Windows XP
echo.
echo  Dieses Skript bentigt Administratorrechte zur korrekten Ausfhrung!
echo.
echo  ____________________________________________________________________________

echo.
pause

cls
echo.

for /F "tokens=1,8 delims=&:" %%i IN ('devcon find pci\*') do call :ListDaFilteredPCIs %%i "%%j"

echo.
set VendorID=14E4
echo Welche Vendor-ID soll zum Blinken gebracht werden (autom. Standard: 14E4)?
Set /P VendorID= -^> PCI\VEN_

echo.

:: ---------------------------------------------------------------------------------------------------------
:: Aktuellen Status des Device merken, um ihn am Ende wieder auf diesen Zustand zu setzen:
:: Ausgabe von Status enthlt wahlweise
::    "Device is disabled."
:: oder
::    "Driver is running."

devcon status PCI\VEN_%VendorID% | find "running"

if "%errorlevel%"=="1" (
   set initialDevStatus=OFF
) else (
   set initialDevStatus=ON
)

echo     Aktueller Status von PCI\VEN_%VendorID%: %initialDevStatus%
:: ---------------------------------------------------------------------------------------------------------


echo.
set Anzahl=5
echo Wie oft soll der Zustand gewechselt werden?
set /P Anzahl= (autom. Standard: 5 [Dauer ca. 40 Sek.]) -^>  
echo.

FOR /L %%i IN (1,1,%Anzahl%) DO call :ToggleDaOnOffStatus PCI\VEN_%VendorID%


:: ---------------------------------------------------------------------------------------------------------
:: DeviceStatus auf Ausgangszustand zurcksetzen
:: Da die Unterroutine "ToggleDaOnOffStatus" das Device immer ENABLED zurcklt,
:: mu hier nur gegebenenfalls DISABLED werden.
   if "%initialDevStatus%"=="OFF" devcon disable %DeviceToToggle%

:: ---------------------------------------------------------------------------------------------------------


goto ENDE


:: ============================================================================
:: ============================================================================

:ListDaFilteredPCIs
   set DeviceVendor=%1
   set DeviceName=%~2
   echo %DeviceVendor% %DeviceName%
   goto :EOF
   
:ToggleDaOnOffStatus
   set DeviceToToggle=%1
   devcon disable %DeviceToToggle% >NUL
   devcon enable  %DeviceToToggle% >NUL
   echo %DeviceToToggle% getoggelt.
   goto :EOF

:: ============================================================================
:: ============================================================================

:ENDE


pause   
endlocal
